力扣第84题:完全平方数

第一部分:问题描述

给你一个整数 n ,返回 和为 n 的完全平方数的最少数量** 。

完全平方数 是一个整数,其值等于另一个整数的平方;换句话说,其值等于一个整数自乘的积。例如,1、4、9 和 16 都是完全平方数,而 3 和 11 不是。

示例 1:

复制代码
输入:n = 12

输出:3 
解释:12 = 4 + 4 + 4

示例 2:

复制代码
输入:n = 13

输出:2
解释:13 = 4 + 9

第二部分:代码实现

(1)核心思想

①定义 dp[i]:表示和为 i 的完全平方数的最少数量。

②状态转移:要得到 i,可以从 i - k² 加一个完全平方数 k² 得到,所以:

因为 k 可以取很多值(1, 2, 3...),每种取值都会得到一个方案数:

  • 选 1²:dp[12-1] + 1 = dp[11] + 1
  • 选 2²:dp[12-4] + 1 = dp[8] + 1
  • 选 3²:dp[12-9] + 1 = dp[3] + 1

我们要从这些方案中选出数量最少 的那个,所以外面套了一个 min()。

③边界条件:dp[0] = 0(和为 0 需要 0 个平方数)。

(2)完整提交代码

复制代码
class Solution:
    def numSquares(self, n: int) -> int:
        #初始化dp数组,dp[i]初始化为最坏情况(全用1的平方,总共i个)
        dp=[i for i in range(n+1)]#写到n+1是因为一会要用到dp[n]
        for i in range(1,n+1):
            #遍历所有小于等于i的平方数
            for k in range(1,int(math.sqrt(i)+1)):#sqrt是根号的意思
                square=k*k
                dp[i]=min(dp[i],dp[i-square]+1)
        return dp[n]

代码解析:

  • 初始化 :dp = [i for i in range(n + 1)]
    • 最坏情况:每个数都由 i 个 1² 组成,所以 dp[i] = i。
  • 外层循环 :遍历 1 到 n,计算每个数的最小平方数数量。
  • 内层循环 :遍历所有小于等于 i 的平方数 k²,更新 dp[i]:
    • dp[i] = min(dp[i], dp[i - square] + 1):比较当前值和「用 k² 加上 i - square 的最小数量」哪个更小。
  • 返回结果 :dp[n] 就是和为 n 的最少完全平方数数量。
相关推荐
不会就选b7 小时前
算法日常・每日刷题--<贪心>25
数据结构·算法
西部驯兽师9 小时前
制造企业的信息化选型课题(一)
职场和发展
Cccp.12311 小时前
【leetcode】(七)前缀树和贪心算法
数据结构·leetcode·贪心算法
天真小巫11 小时前
2026.9.28总结
职场和发展
千里码aicood11 小时前
基于CART算法的图书分类系统设计与实现
数据库·算法·分类
我命由我1234511 小时前
经纪人的职业定义
经验分享·笔记·学习·职场和发展·求职招聘·职场发展·学习方法
做cv的小昊11 小时前
【World Model】π0.5:a Vision-Language-Action Model with Open-World Generalization
人工智能·算法·机器学习·大模型·多模态·vla·世界模型
لا معنى له12 小时前
World-In-World: World Models in a Closed-Loop World
算法
hqyjzsb14 小时前
法律 Prompt 干货:搭建合同审查提示词要包含哪些要素
开发语言·人工智能·python·职场和发展·数据分析·prompt·业界资讯